/* Copyright (C) 2000-2015 Lavtech.com corp. All rights reserved.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
*/

#ifndef _UDM_ENV_H
#define _UDM_ENV_H

UDM_API(void) UdmEnvInit(UDM_ENV *);
UDM_API(void) UdmEnvFree(UDM_ENV *);
UDM_API(const char*) UdmEnvErrMsg(UDM_ENV *);

udm_rc_t UdmEnvPrepare(UDM_ENV *Env);
udm_rc_t UdmEnvDBListAdd(UDM_ENV *Env, const char *dbaddr);

UDM_API(void) UdmSetLockProc(UDM_ENV * Conf,
                             void (*proc)(UDM_AGENT *A,
                                          udm_mutexcmd_t command,
                                          udm_mutexno_t number,
                                          const char *fname,
                                          int lineno));
size_t UdmEnvSectionMaxLength(const UDM_ENV *Env, udm_secno_t secno);
size_t UdmEnvSectionMaxLengthEx(const UDM_ENV *Env,
                                udm_secno_t secno, const char *name);
#endif
