/* Copyright (C) 2000-2015 Lavtech.com corp. All rights reserved.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
*/

#ifndef _UDM_WORD_H
#define _UDM_WORD_H

/****** UDM_WORD routines ******/
udm_rc_t UdmWordListAddEx(UDM_WORDLIST *List, const char *word,
                            size_t secno, size_t wordpos, size_t where);
udm_rc_t UdmWordListAdd(UDM_WORDLIST* List,char *word,int where);
void UdmWordListFree(UDM_WORDLIST * List);
udm_rc_t UdmWordListSaveSectionSize(UDM_WORDLIST *Doc);
UDM_WORDLIST * UdmWordListInit(UDM_WORDLIST * List);
void UdmWordListReset(UDM_WORDLIST *List);

/***** UDM_CONSTWORD routines ******/
void UdmConstWordListInit(UDM_CONSTWORDLIST *L);
void UdmConstWordListFree(UDM_CONSTWORDLIST *L);
udm_rc_t UdmConstWordListAdd(UDM_CONSTWORDLIST *L, UDM_CONSTWORD *W);
void UdmConstWordListSort(UDM_CONSTWORDLIST *WL);
udm_rc_t UdmConstWordListAddString(UDM_WORD_SCANNER *scanner,
                                   int cnvflags,
                                   UDM_CONSTWORDLIST *CWL,
                                   udm_secno_t secno,
                                   const char *src, size_t srclen);


/****** UDM_WIDEWORD routines ******/
void UdmWideWordParamInit(UDM_WIDEWORD_PARAM *P);
void UdmWideWordParamCopySpell(UDM_WIDEWORD_PARAM *Dst, const UDM_WIDEWORD_PARAM *Src);
void UdmWideWordParamCopySynonym(UDM_WIDEWORD_PARAM *Dst, const UDM_WIDEWORD_PARAM *Src);
void UdmWideWordInit(UDM_WIDEWORD *W);
void UdmWideWordFree(UDM_WIDEWORD *W);

UDM_WIDEWORDLIST * UdmWideWordListInit(UDM_WIDEWORDLIST * List);
size_t UdmWideWordListAdd(UDM_WIDEWORDLIST * List,UDM_WIDEWORD * Word);
size_t UdmWideWordListAddLike(UDM_WIDEWORDLIST *WWList,
                              UDM_WIDEWORD_PARAM *param,
                              const char *word);
size_t UdmWideWordListAddLikeConstStr(UDM_WIDEWORDLIST *WWList,
                                      UDM_WIDEWORD_PARAM *param,
                                      UDM_CONST_STR str);
size_t UdmWideWordListAddForStat(UDM_WIDEWORDLIST * List,UDM_WIDEWORD * Word);
void UdmWideWordListFree(UDM_WIDEWORDLIST * List);
udm_rc_t UdmWideWordListCopy(UDM_WIDEWORDLIST *Dst, UDM_WIDEWORDLIST *Src);

void UdmWordListListInit(UDM_WORDLISTLIST *LL);
void UdmWordListListReset(UDM_WORDLISTLIST *LL);
void UdmWordListListFree(UDM_WORDLISTLIST *LL);

udm_rc_t UdmWideWordListMakeRange(UDM_WIDEWORDLIST *LL, int beg, int end);

void UdmWideWordListSort(UDM_WIDEWORDLIST *LL);

#endif
